import type { ElTree } from 'element-plus';
import type { Ref } from 'vue';
import { ref, watch } from 'vue';
import { debounce } from '/@/utils/util';
interface Tree {
	[key: string]: any;
}
/**
 * 过滤 el-tree 节点
 * @param treeRef
 * @param label
 */
export const useFilterTree = (treeRef: Ref<InstanceType<typeof ElTree>>, label = 'Name') => {
	const filterText = ref('');

	watch(
		filterText,
		debounce(function (...args) {
			treeRef.value!.filter(args[0]);
		})
	);

	const filterNode = (value: string, data: Tree) => {
		if (!value) return true;
		return data[label].includes(value.trim().toLowerCase());
	};

	return {
		filterText,
		filterNode,
	};
};
